// CTOzekiMS6ClientEvents.cpp : implementation file
//

#include "stdafx.h"
#include "cppClient.h"
#include "CTOzekiMS6ClientEvents.h"
#include "ozCOMClient_i.c"


// CTOzekiMS6ClientEvents

IMPLEMENT_DYNAMIC(CTOzekiMS6ClientEvents, CCmdTarget)
CTOzekiMS6ClientEvents::CTOzekiMS6ClientEvents()
{
	EnableAutomation();
}

CTOzekiMS6ClientEvents::~CTOzekiMS6ClientEvents()
{
}


void CTOzekiMS6ClientEvents::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CTOzekiMS6ClientEvents, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CTOzekiMS6ClientEvents, CCmdTarget)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onError",1,onError, VT_EMPTY, VTS_I2 VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onServerConnected",2,onServerConnected, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onServerConnecting",3,onServerConnecting, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onServerCouldNotConnect",4,onServerCouldNotConnect, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onServerDisconnected",5,onServerDisconnected, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSAccepted",6,onSMSAccepted, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSDelivered",7,onSMSDelivered, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSReceived",8,onSMSReceived, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSRejected",9,onSMSRejected, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSTransmitted",10,onSMSTransmitted, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION_ID(CTOzekiMS6ClientEvents, "onSMSUndeliverable",11,onSMSUndeliverable, VT_EMPTY, VTS_BSTR)

END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CTOzekiMS6ClientEvents, CCmdTarget)
	INTERFACE_PART(CTOzekiMS6ClientEvents, DIID_ITOzekiMS6ClientEvents, Dispatch)
END_INTERFACE_MAP()
	


void CTOzekiMS6ClientEvents::onError(long statusCode, LPCTSTR statusMessage)
	{
        MessageBox(0,"Ozeki MS6 error","Cppclient",MB_OK);		
	}
	
void CTOzekiMS6ClientEvents::onServerConnected(void)
	{
		theApp.dlg->addToLog("Successfully connected");
	}
void CTOzekiMS6ClientEvents::onServerConnecting(void)
	{
		theApp.dlg->addToLog("Connecting");
	}
void CTOzekiMS6ClientEvents::onServerCouldNotConnect(void)
	{
		theApp.dlg->addToLog("Could not connect");
	}
void CTOzekiMS6ClientEvents::onServerDisconnected(void)
	{
		theApp.dlg->addToLog("Disconnected");
	}
void CTOzekiMS6ClientEvents::onSMSAccepted(LPCTSTR smsID)
	{
		CString msg="SMS Accpeted for delivery, ID: ";
		msg.Append(smsID);
		theApp.dlg->addToLog(msg);
	}
void CTOzekiMS6ClientEvents::onSMSDelivered(LPCTSTR smsID)
	{
		CString msg="SMS Delivered, ID:";
		msg.Append(smsID);
		theApp.dlg->addToLog(msg);
	}
void CTOzekiMS6ClientEvents::onSMSReceived(LPCTSTR originator, LPCTSTR recepient, LPCTSTR messageData, LPCTSTR messageType, LPCTSTR operatorname)
	{
		CString msg="SMS Received: ";
		msg.Append(originator);
		msg.Append(" -> ");
		msg.Append(recepient);
		msg.Append(" '");
		msg.Append(messageData);
		msg.Append("' ");
		theApp.dlg->addToLog(msg);
	}
void CTOzekiMS6ClientEvents::onSMSRejected(LPCTSTR smsID)
	{
		CString msg="SMS Rejected, ID:";
		msg.Append(smsID);
		theApp.dlg->addToLog(msg);
	}
void CTOzekiMS6ClientEvents::onSMSTransmitted(LPCTSTR smsID)
	{
		CString msg="SMS Transmitted, ID:";
		msg.Append(smsID);
		theApp.dlg->addToLog(msg);
	}
void CTOzekiMS6ClientEvents::onSMSUndeliverable(LPCTSTR smsID)
	{
		CString msg="SMS Undeliverable, ID:";
		msg.Append(smsID);
		theApp.dlg->addToLog(msg);
	}