// cppClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cppClient.h"
#include "ozCOMClient_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//#import "ozCOMClient.dll" rename_namespace("MS6Client")


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CcppClientDlg dialog

CcppClientDlg::CcppClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CcppClientDlg::IDD, pParent)
	, eServerIP(_T("127.0.0.1"))
	, ePort(_T("9334"))
	, eUserName(_T("admin"))
	, ePassword(_T("abc123"))
	, ePhoneNumber(_T("+36203105366"))
	, eMsgText(_T("Hello world!"))
	, eLog(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CcppClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EPORT, ePort);
	DDX_Text(pDX, IDC_EUSER, eUserName);
	DDX_Text(pDX, IDC_EDIT2, eServerIP);
	DDX_Text(pDX, IDC_EPASS, ePassword);
	DDX_Text(pDX, IDC_EPHONENUM, ePhoneNumber);
	DDX_Text(pDX, IDC_EMSG, eMsgText);
	DDX_Text(pDX, IDC_EDIT1, eLog);
	DDX_Control(pDX, IDC_BDISCONNECT, bDisconnect);
	DDX_Control(pDX, IDC_BSEND, bSend);
	DDX_Control(pDX, IDC_BCONNECT, bConnect);
}

BEGIN_MESSAGE_MAP(CcppClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	
	ON_BN_CLICKED(IDC_BCONNECT, OnBnClickedBconnect)
	ON_BN_CLICKED(IDC_BSEND, OnBnClickedBsend)
	ON_BN_CLICKED(IDC_BDISCONNECT, OnBnClickedBdisconnect)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CcppClientDlg message handlers

BOOL CcppClientDlg::OnInitDialog()
{

//	MessageBox("Dialog INIT","Dilogproc",MB_OK);
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	

	// Attach to the COM client
	if(!ozms6.CreateDispatch(CLSID_TOzekiMS6Client))
	{
	   clientAttached = false;
	   bConnect.EnableWindow(false);
       AfxMessageBox("Cannot attach to Ozeki COM client object. It might not be registered. \r\n Please type 'regsvr32 ozCOMClient.dll' in a command window!");
	} else {   
		clientAttached = true;
		ms6events = new CTOzekiMS6ClientEvents;
		LPUNKNOWN m_pUnk=ms6events->GetIDispatch(FALSE);
		if (!(AfxConnectionAdvise(ozms6,DIID_ITOzekiMS6ClientEvents,m_pUnk,FALSE,&dwCookie))) 
			clientAttached=false;
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CcppClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (lParam==WM_APP) {
		eLog = myLog;
		UpdateData(FALSE);
	} else if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CcppClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CcppClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CcppClientDlg::OnBnClickedBconnect()
{
	// Get variables from the dialog
	UpdateData(TRUE);

	if (clientAttached) {
       ozms6.put_ServerIP(eServerIP);
       ozms6.put_ServerPort(atoi(ePort));
       ozms6.put_UserName(eUserName);
       ozms6.put_Password(ePassword);
       ozms6.put_Connected(true);
       bConnect.EnableWindow(false);
	   bDisconnect.EnableWindow(true);
	   bSend.EnableWindow(true);
	} 
	
}

void CcppClientDlg::OnBnClickedBsend()
{
	if (clientAttached) {
	   UpdateData(TRUE);
   
	   VARIANT messageID = ozms6.sendSMSEx("+36201111111",ePhoneNumber,"SMS:TEXT",eMsgText,"Vodafone1");
	   CString logEntry = "Sending message with ID: ";
	   logEntry.Append((CString)messageID);
	   addToLog(logEntry);
	}
}

void CcppClientDlg::OnBnClickedBdisconnect()
{
	ozms6.put_Connected(false);
	bDisconnect.EnableWindow(false);
	bSend.EnableWindow(false);
	bConnect.EnableWindow(true);
}

void CcppClientDlg::addToLog(CString message) {
	myLog.Append(message);
	myLog.Append("\r\n");

	//When events are received from the COM interface
	//the dialog cannot be updated, so we post a message
	//to ourselves to update the dialog.
	PostMessage(WM_SYSCOMMAND,0,WM_APP);
};

void CcppClientDlg::OnDestroy()
{
	LPUNKNOWN m_pUnk=ms6events->GetIDispatch(FALSE);
	AfxConnectionUnadvise(ozms6,DIID_ITOzekiMS6ClientEvents,m_pUnk,FALSE,dwCookie);
	if(ms6events!=NULL)	{
		delete ms6events; 
		ms6events=NULL;
	}

	if (clientAttached) {
	    ozms6.ReleaseDispatch();
	}
	ozms6 = NULL;

	CDialog::OnDestroy();

}


